***STATE HIRING CREDITS***
*Neumark - Grijalva 2016
*Forthcoming ILRR
*Table 11 

clear
set more off
set matsize 2000

global data "C:\Users\Diego\Documents\Documents\USFQ\Publications\JCHC\Replication\data\Monthly"

cd $data
use JCHCdatabase_monthly, clear

*Merge cyclical indicator
merge 1:1 sname year month using pse90final
drop _merge

*Merge political variables
merge 1:1 sname year month using political_variables
drop _merge
 
*Merge Unemployment Insurance Data
merge 1:1 state year month using uiweekcontrols
drop _merge

*Drop the District of Columbia
drop if state==11

*Save results in a Matrix for easy saving
*The first row is the coefficient
*The second row is the standard error
matrix input linco = (0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0\0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
gen k=1

sort state year month

by state: gen n1 = _n

*Convert credit counts to dummies for 1 = at least one credit, 0 = none
*Generate lags of these variables
foreach var of varlist jc aet acf ar ans recp nrecp {
	   quietly replace `var' = 1 if `var'>1 & `var'~=.
	   quietly gen `var'1 = `var'[_n-1] if state[_n] == state[_n-1]
	   quietly gen `var'2 = `var'[_n-2] if state[_n] == state[_n-2]
	   quietly gen `var'3 = `var'[_n-3] if state[_n] == state[_n-3]
	   quietly gen `var'4 = `var'[_n-4] if state[_n] == state[_n-4]
	   quietly gen `var'5 = `var'[_n-5] if state[_n] == state[_n-5]
	   quietly gen `var'6 = `var'[_n-6] if state[_n] == state[_n-6]
	   quietly gen `var'7 = `var'[_n-7] if state[_n] == state[_n-7]
	   quietly gen `var'8 = `var'[_n-8] if state[_n] == state[_n-8]
	   quietly gen `var'9 = `var'[_n-9] if state[_n] == state[_n-9]
	   quietly gen `var'10 = `var'[_n-10] if state[_n] == state[_n-10]
	   quietly gen `var'11 = `var'[_n-11] if state[_n] == state[_n-11]
	   quietly gen `var'12 = `var'[_n-12] if state[_n] == state[_n-12]
	   quietly gen `var'13 = `var'[_n-13] if state[_n] == state[_n-13]
	   
	   *First Differences
	   quietly gen d`var' = `var' - `var'1
	   quietly gen d`var'1 = `var'1 - `var'2
	   quietly gen d`var'2 = `var'2 - `var'3
	   quietly gen d`var'3 = `var'3 - `var'4
	   quietly gen d`var'4 = `var'4 - `var'5
	   quietly gen d`var'5 = `var'5 - `var'6
	   quietly gen d`var'6 = `var'6 - `var'7
	   quietly gen d`var'7 = `var'7 - `var'8
	   quietly gen d`var'8 = `var'8 - `var'9
	   quietly gen d`var'9 = `var'9 - `var'10
	   quietly gen d`var'10 = `var'10 - `var'11
	   quietly gen d`var'11 = `var'11 - `var'12
	   quietly gen d`var'12 = `var'12 - `var'13
	}

*Same thing but for lpse4naics, lminwage, and weeks_euc
foreach var of varlist lminwage weeks_euc lpse4naics {
	   quietly gen `var'1 = `var'[_n-1] if state[_n] == state[_n-1]
	   quietly gen `var'2 = `var'[_n-2] if state[_n] == state[_n-2]
	   quietly gen `var'3 = `var'[_n-3] if state[_n] == state[_n-3]
	   quietly gen `var'4 = `var'[_n-4] if state[_n] == state[_n-4]
	   quietly gen `var'5 = `var'[_n-5] if state[_n] == state[_n-5]
	   quietly gen `var'6 = `var'[_n-6] if state[_n] == state[_n-6]
	   quietly gen `var'7 = `var'[_n-7] if state[_n] == state[_n-7]
	   quietly gen `var'8 = `var'[_n-8] if state[_n] == state[_n-8]
	   quietly gen `var'9 = `var'[_n-9] if state[_n] == state[_n-9]
	   quietly gen `var'10 = `var'[_n-10] if state[_n] == state[_n-10]
	   quietly gen `var'11 = `var'[_n-11] if state[_n] == state[_n-11]
	   quietly gen `var'12 = `var'[_n-12] if state[_n] == state[_n-12]
	   quietly gen `var'13 = `var'[_n-13] if state[_n] == state[_n-13]
	   
	   *First Differences
	   quietly gen d`var' = `var' - `var'1
	   quietly gen d`var'1 = `var'1 - `var'2
	   quietly gen d`var'2 = `var'2 - `var'3
	   quietly gen d`var'3 = `var'3 - `var'4
	   quietly gen d`var'4 = `var'4 - `var'5
	   quietly gen d`var'5 = `var'5 - `var'6
	   quietly gen d`var'6 = `var'6 - `var'7
	   quietly gen d`var'7 = `var'7 - `var'8
	   quietly gen d`var'8 = `var'8 - `var'9
	   quietly gen d`var'9 = `var'9 - `var'10
	   quietly gen d`var'10 = `var'10 - `var'11
	   quietly gen d`var'11 = `var'11 - `var'12
	   quietly gen d`var'12 = `var'12 - `var'13
	}

*Generate linear growth for credit variables
foreach var of varlist jc aet acf ar ans recp nrecp {
	   gen l`var' = 0
	   replace l`var' = 1/12 if `var'[_n]==1 & `var'[_n-1]==0 & state[_n] == state[_n-1]
	   replace l`var' = 2/12 if  `var'[_n]==1 & l`var'[_n-1]>0  & l`var'[_n-2]==0 & state[_n] == state[_n-2]
	   replace l`var' = 3/12 if  `var'[_n]==1 & l`var'[_n-2]>0  & l`var'[_n-3]==0 & state[_n] == state[_n-3]
	   replace l`var' = 4/12 if  `var'[_n]==1 & l`var'[_n-3]>0  & l`var'[_n-4]==0 & state[_n] == state[_n-4]
	   replace l`var' = 5/12 if  `var'[_n]==1 & l`var'[_n-4]>0  & l`var'[_n-5]==0 & state[_n] == state[_n-5]
	   replace l`var' = 6/12 if  `var'[_n]==1 & l`var'[_n-5]>0 & l`var'[_n-6]==0 & state[_n] == state[_n-6]
	   replace l`var' = 7/12 if  `var'[_n]==1 & l`var'[_n-6]>0  & l`var'[_n-7]==0 & state[_n] == state[_n-7]
	   replace l`var' = 8/12 if  `var'[_n]==1 & l`var'[_n-7]>0  & l`var'[_n-8]==0 & state[_n] == state[_n-8]
	   replace l`var' = 9/12 if  `var'[_n]==1 & l`var'[_n-8]>0  & l`var'[_n-9]==0 & state[_n] == state[_n-9]
	   replace l`var' = 10/12 if `var'[_n]==1 & l`var'[_n-9]>0  & l`var'[_n-10]==0 & state[_n] == state[_n-10]
	   replace l`var' = 11/12 if `var'[_n]==1 & l`var'[_n-10]>0 & l`var'[_n-11]==0 & state[_n] == state[_n-11]
	   replace l`var' = 12/12 if `var'[_n]==1 & l`var'[_n-11]>0 & l`var'[_n-12]==0 & state[_n] == state[_n-12]
	   replace l`var' = 13/12 if `var'[_n]==1 & l`var'[_n-12]>0 & l`var'[_n-13]==0 & state[_n] == state[_n-13]	   
	   replace l`var' = 13/12 if `var'[_n]==1 & n1==1
	   replace l`var' = 13/12 if `var'[_n]==1 & l`var'[_n-1]>1 & state[_n] == state[_n-1]
	}
	
*Generate First Differences of the linear growth 
foreach var of varlist ljc laet lacf lar lans lrecp lnrecp {
	gen d`var' = `var'[_n] - `var'[_n-1] if state[_n] == state[_n-1]
}

*Generate quadratic term of the linear growth 
foreach var of varlist ljc laet lacf lar lans lrecp lnrecp {
	gen `var'2 = `var'[_n]*`var'[_n]
	gen d`var'2 = `var'2[_n] - `var'2[_n-1] if state[_n] == state[_n-1]
}

*Generate lags of the political variables
*Generate first differences of these variables
foreach var of varlist govparty_c {
quietly gen `var'1 = `var'[_n-1] if state[_n] == state[_n-1]

quietly gen d`var' = `var' - `var'1
}

*First Difference of log employment
gen dll = ll[_n] - ll[_n-1] if state[_n]==state[_n-1]

*Select the proper years of data for the sample
drop if year <= 1994 | year == 2012

*INTERACIONS


*State dummies
sort state year month
egen statedum = group(state)
quietly tab statedum, generate (sdum)
drop statedum

*Month dummies
egen timedum = group(year month)
sort timedum
quietly tab timedum, generate(mdum)
drop timedum

*Calendar month dummies
egen monthlydum = group(month)
quietly tab monthlydum, generate(monthdum)
drop monthlydum

*Interactions
foreach var1 of varlist sdum* {
foreach var2 of varlist monthdum* {
gen int`var1'`var2' = `var1' *`var2'
}
}

foreach var of varlist sdum* {
gen int`var'lpse4naics = `var' * lpse4naics
}

sort state year month

*First differences of interactions
foreach var of varlist mdum* intsdum*monthdum* intsdum*lpse4naics {
quietly gen d`var' = `var'[_n] - `var'[_n-1] if state[_n] == state[_n-1]
}

*Program to produce a matrix of linear tests
capture program drop linearcombos
program define linearcombos

lincom `1'
matrix linco[1,k] = r(estimate)
matrix linco[2,k] = r(se)
replace k=k+1

end

***REGRESSIONS***

drop dintsdum1lpse4naics mdum1 mdum2 intsdum1monthdum*

global int dlpse4naics* dlminwage* dweeks_euc* intsdum*monthdum* mdum* dintsdum*lpse4naics

global pol govparty_c

*Credit
reg dll dljc dljc2 $int $pol, vce(cluster state)

linearcombos dljc
linearcombos dljc2

*Amount of credit
reg dll dlaet dlacf dlar dlans dlaet2 dlacf2 dlar2 dlans2 $int $pol, vce(cluster state)

linearcombos dlaet
linearcombos dlaet2
linearcombos dlacf
linearcombos dlacf2
linearcombos dlar
linearcombos dlar2
linearcombos dlans
linearcombos dlans2

*Recapture provisions
reg dll dlrecp dlnrecp dlrecp2 dlnrecp2 $int $pol, vce(cluster state)

linearcombos dlrecp
linearcombos dlrecp2
linearcombos dlnrecp
linearcombos dlnrecp2

***RESULTS***

matrix list linco
matrix lincot=linco'

putexcel set TableA1, sheet(Results) modify
putexcel B2 = matrix(lincot)
